/*
 * Copyright (c) 2019 - Manifold Systems LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package manifold.preprocessor.expression;

enum ExpressionTokenType
{
  Whitespace(),
  StringLiteral(),
  Identifier(),
  OpenParen( "(" ),
  CloseParen( ")" ),
  And( "&&" ),
  Or( "||" ),
  Not( "!" ),
  Equals( "==" ),
  NotEquals( "!=" );

  private String _token;

  ExpressionTokenType()
  {
    this( null );
  }

  ExpressionTokenType( String token )
  {
    _token = token;
  }

  boolean getToken()
  {
    return _token != null;
  }

  String getDirective()
  {
    return _token;
  }
}
